commit 4a11617127599c2a40552f5f7e9bf0e863f10e8d
Merge: d9081efac d46a67277
Author: Heiko Schlittermann (HS12-RIPE) <hs@schlittermann.de>
Date:   Tue Dec 16 12:55:32 2025 +0100

    Merge branch 'exim-4.99+fixes' (EXIM-Security-2025-12-09.1, CVE-2025-67896)
    
    * exim-4.99+fixes:
      doc: update about CVE-2025-67896
      fix: release process docbook2texi
      EXIM-Security-2025-12-09.1
      doc: update Changelog (relates #7)
      Testsuite: add testing for sqlite db external usage
      return scan result into key parameter
      move to blobs for keys as well as data. refactor sqlite3_ calls to reduce duplication
      new: xtextencode
      CVE-2025-30232
      Squashed from fix/cve-2025-26794 (fixes CVE-26794)

diff --git a/src/src/hintsdb.h b/src/src/hintsdb.h
index d2d30969b..9a65d8b19 100644
--- a/src/src/hintsdb.h
+++ b/src/src/hintsdb.h
@@ -67,6 +67,7 @@ required by Exim's process transitions)?
 
 /* Include file ordering problem */
 extern void    debug_printf_indent(const char *, ...) PRINTF_FUNCTION(1,2);
+static inline BOOL is_tainted(const void *);
 
 
 #ifdef USE_SQLITE
@@ -102,15 +103,8 @@ the default is the NDBM interface (which seems to be a wrapper for GDBM) */
 #endif /* !USE_GDBM */
 
 
-
-
-
-
 /* Wrappers for open/close with debug tracing */
 
-extern void debug_printf_indent(const char *, ...);
-static inline BOOL is_tainted(const void *);
-
 static inline EXIM_DB *
 exim_dbopen(const uschar * name, const uschar * dirname, int flags,
   unsigned mode)
diff --git a/src/src/hintsdb/hints_sqlite.h b/src/src/hintsdb/hints_sqlite.h
index 40d50b8c0..dd88dd98b 100644
--- a/src/src/hintsdb/hints_sqlite.h
+++ b/src/src/hintsdb/hints_sqlite.h
@@ -17,7 +17,7 @@ backend provider. */
 /* Basic DB type */
 # define EXIM_DB sqlite3
 
-# define EXIM_CURSOR int
+# define EXIM_CURSOR sqlite3_stmt
 
 # /* The datum type used for queries */
 # define EXIM_DATUM blob
@@ -25,12 +25,6 @@ backend provider. */
 /* Some text for messages */
 # define EXIM_DBTYPE "sqlite3"
 
-/* Utility functionss */
-
-extern uschar *xtextencode(const uschar *, int);
-extern int xtextdecode(const uschar *, uschar**);
-
-
 /* Access functions */
 
 static inline BOOL
@@ -54,10 +48,12 @@ if ((ret = sqlite3_open_v2(CCS name, &dbp, sflags, NULL)) == SQLITE_OK)
   sqlite3_busy_timeout(dbp, 5000);
   if (flags & O_CREAT)
     ret = sqlite3_exec(dbp,
-	    "CREATE TABLE IF NOT EXISTS tbl (ky TEXT PRIMARY KEY, dat BLOB);",
+	    "CREATE TABLE IF NOT EXISTS tblblob (ky BLOB PRIMARY KEY, dat BLOB);",
 	    NULL, NULL, NULL);
   if (ret != SQLITE_OK)
     sqlite3_close(dbp);
+  /* in case we are migrating, drop the old table, return code not needed */
+  (void) sqlite3_exec(dbp, "DROP TABLE IF EXISTS tbl;", NULL, NULL, NULL);
   }
 else DEBUG(D_hints_lookup)
   debug_printf_indent("sqlite_open(flags 0x%x mode %04o) %s\n",
@@ -82,148 +78,143 @@ sqlite3_close(dbp);
 return NULL;
 }
 
-/* EXIM_DBGET - returns TRUE if successful, FALSE otherwise */
-/* note we alloc'n'copy - the caller need not do so */
-/* result has a NUL appended, but the length is as per the DB */
-
-static inline BOOL
-exim_dbget__(EXIM_DB * dbp, const uschar * s, EXIM_DATUM * res)
+static inline sqlite3_stmt *
+exim_sqlbind_blob(EXIM_DB * dbp, sqlite3_stmt *stmt, int *bindcolp, EXIM_DATUM *data )
 {
-sqlite3_stmt * statement;
-int ret;
-
-res->len = (size_t) -1;
-/* DEBUG(D_hints_lookup) debug_printf_indent("exim_dbget__(%s)\n", s); */
-if ((ret = sqlite3_prepare_v2(dbp, CCS s, -1, &statement, NULL)) != SQLITE_OK)
+if (data && stmt)
   {
-  DEBUG(D_hints_lookup)
-    debug_printf_indent("prepare fail: %s\n", sqlite3_errmsg(dbp));
-  return FALSE;
-  }
-if (sqlite3_step(statement) != SQLITE_ROW)
-  {
-  /* DEBUG(D_hints_lookup)
-    debug_printf_indent("step fail: %s\n", sqlite3_errmsg(dbp)); */
-  sqlite3_finalize(statement);
-  return FALSE;
-  }
-
-res->len = sqlite3_column_bytes(statement, 0);
-# ifdef COMPILE_UTILITY
-if (!(res->data = malloc(res->len +1)))
-  { sqlite3_finalize(statement); return FALSE; }
-# else
-res->data = store_get(res->len +1, GET_TAINTED);
+  if (SQLITE_OK != sqlite3_bind_blob(stmt, *bindcolp, data->data, data->len, SQLITE_STATIC))
+    {
+# ifdef SQL_DEBUG
+    fprintf(stderr, EXIM_DBTYPE " bind to value %d: %s\n", *bindcolp, sqlite3_errmsg(dbp));
 # endif
-memcpy(res->data, sqlite3_column_blob(statement, 0), res->len);
-res->data[res->len] = '\0';
-/* DEBUG(D_hints_lookup) debug_printf_indent("res %d bytes: '%.*s'\n",
-				  (int)res->len, (int)res->len, res->data); */
-sqlite3_finalize(statement);
-return TRUE;
+    sqlite3_finalize(stmt);
+    stmt = NULL;
+    }
+  else
+    {
+    (*bindcolp)++;
+    }
+  }
+return stmt;
 }
 
-static inline BOOL
-exim_dbget(EXIM_DB * dbp, EXIM_DATUM * key, EXIM_DATUM * res)
+/* We use a common prepare/bind mechanism with optional value binding */
+static inline sqlite3_stmt *
+exim_sqlprep(EXIM_DB * dbp, const char *query, EXIM_DATUM *key, EXIM_DATUM *data )
 {
-# define FMT "SELECT dat FROM tbl WHERE ky = '%s';"
-uschar * encoded_key, * qry;
-BOOL ret;
+sqlite3_stmt * stmt = NULL; /* don't make it static, as it depends on the dbp */
+int bindcol = 1;
 
-# ifdef COMPILE_UTILITY
-if (!(encoded_key = xtextencode(key->data, key->len)))
-  return FALSE;
-# else
-encoded_key = xtextencode(key->data, key->len);
+if (SQLITE_OK != sqlite3_prepare_v2(dbp, query, strlen(query), &stmt, NULL))
+  {
+# ifdef SQL_DEBUG
+  fprintf(stderr, EXIM_DBTYPE " prepare %s: %s\n", query, sqlite3_errmsg(dbp));
 # endif
-/* DEBUG(D_hints_lookup) debug_printf_indent("exim_dbget(k len %d '%s')\n",
-				  (int)key->len, encoded_key); */
+  goto DONE;
+  }
 
-# ifdef COMPILE_UTILITY
+# ifdef SQL_DEBUG
+DEBUG(D_hints_lookup) debug_printf_indent("prepared SQL: %s\n", sqlite3_sql(stmt));
+# endif
+
+stmt = exim_sqlbind_blob(dbp, stmt, &bindcol, key);
+stmt = exim_sqlbind_blob(dbp, stmt, &bindcol, data);
+
+# ifdef SQL_DEBUG
+if (stmt)
   {
-  int i = snprintf(NULL, 0, FMT, encoded_key) + 1;
-  if (!(qry = malloc(i)))
-    return FALSE;
-  snprintf(CS qry, i, FMT, encoded_key);
-  ret = exim_dbget__(dbp, qry, res);
-  free(qry);
+  DEBUG(D_hints_lookup) debug_printf_indent("expanded SQL: %s\n", sqlite3_expanded_sql(stmt));
   }
-free(encoded_key);
-# else
-qry = string_sprintf(FMT, encoded_key);
-ret = exim_dbget__(dbp, qry, res);
 # endif
 
-return ret;
-# undef FMT
-}
+DONE:
 
-/* Note that we return claiming a duplicate record for any error.
-It seem not uncommon to get a "database is locked" error.
+return stmt;
+}
 
-Keys are stored xtext-encoded (which is mostly readable, for plaintext).
-Values are stored in a BLOB type in the DB, for which the SQL interface
-is hex-encoded. */
-# define EXIM_DBPUTB_OK  0
-# define EXIM_DBPUTB_DUP (-1)
 
 static inline int
-exim_s_dbp(EXIM_DB * dbp, EXIM_DATUM * key, EXIM_DATUM * data, const uschar * alt)
+exim_sqlstep(EXIM_DB * dbp, sqlite3_stmt * stmt, EXIM_DATUM *res )
 {
-int hlen = data->len * 2, off = 0, res;
-# define FMT "INSERT OR %s INTO tbl (ky,dat) VALUES ('%s', X'%.*s');"
-uschar * encoded_key, * qry;
+int rv = SQLITE_MISUSE;
+
+switch ((rv = sqlite3_step(stmt)))
+  {
+    case SQLITE_DONE: /* might want to call sqlite3_reset(stmt); here */
+                      goto DONE;
+    case SQLITE_ROW:  if (!res)
+                      {
+                        /* allow for fetch but didn't want data (existence check ?) */
+                        goto DONE;
+                      }
+                      res->len = sqlite3_column_bytes(stmt, 0);
 # ifdef COMPILE_UTILITY
-uschar * hex = malloc(hlen+1), dummy[1];
-if (!hex) return EXIM_DBPUTB_DUP;	/* best we can do */
+                      res->data = malloc(res->len +1);
+                      if (! res->data ) goto DONE;
 # else
-uschar * hex = store_get(hlen+1, data->data);
+                      res->data = store_get(res->len +1, GET_TAINTED);
+# endif
+                      memcpy(res->data, sqlite3_column_blob(stmt, 0), res->len);
+                      res->data[res->len] = '\0';
+                      goto DONE;
+    default:
+# ifdef SQL_DEBUG
+                      fprintf(stderr, EXIM_DBTYPE " step: %s: %s\n", sqlite3_expanded_sql(stmt), sqlite3_errmsg(dbp));
 # endif
+                      goto DONE;
+  }
 
-/* Encode the value for the SQL API */
+DONE:
+return rv;
+}
 
-for (const uschar * s = data->data, * t = s + data->len; s < t; s++, off += 2)
-  sprintf(CS hex + off, "%02X", *s);
 
-# ifdef COMPILE_UTILITY
-if (!(encoded_key = xtextencode(key->data, key->len)))
-  return EXIM_DBPUTB_DUP;
-res = snprintf(CS dummy, 0, FMT, alt, encoded_key, hlen, hex) +1;
-if (!(qry = malloc(res))) return EXIM_DBPUTB_DUP;
-snprintf(CS qry, res, FMT, alt, encoded_key, hlen, hex);
-DEBUG(D_hints_lookup) debug_printf_indent("exim_s_dbp(%s)\n", qry);
-
-res = sqlite3_exec(dbp, CS qry, NULL, NULL, NULL);
-free(qry);
-free(encoded_key);
-free(hex);
+/* simplest case when updating a single row or fetching a single row */
+static inline int
+exim_sqlprep_step(EXIM_DB * dbp, const char *query, EXIM_DATUM *key, EXIM_DATUM *data, EXIM_DATUM *res )
+{
+int more = SQLITE_ERROR;
+sqlite3_stmt * stmt = NULL; /* don't make it static, as it depends on the dbp */
 
-# else
-encoded_key = xtextencode(key->data, key->len);
-qry = string_sprintf(FMT, alt, encoded_key, hlen, hex);
-/* DEBUG(D_hints_lookup) debug_printf_indent("exim_s_dbp(%s)\n", qry); */
+if ((stmt = exim_sqlprep(dbp, query, key, data )))
+  {
+    more = exim_sqlstep(dbp, stmt, res );
+    sqlite3_finalize(stmt);
+    stmt = NULL;
+  }
+return more;
+}
 
-res = sqlite3_exec(dbp, CS qry, NULL, NULL, NULL);
-/* DEBUG(D_hints_lookup) debug_printf_indent("exim_s_dbp res %d\n", res); */
-# endif
+/* EXIM_DBGET - returns the value associated with the key. */
+static inline BOOL
+exim_dbget(EXIM_DB * dbp, EXIM_DATUM * key, EXIM_DATUM * res)
+{
+const char query[] = "SELECT dat FROM tblblob WHERE ky = ?";
+return (exim_sqlprep_step(dbp, query, key, NULL, res ) == SQLITE_ROW);
+}
 
-# ifdef COMPILE_UTILITY
-if (res != SQLITE_OK)
-  DEBUG(D_hints_lookup)
-    debug_printf_indent("sqlite3_exec: %s\n", sqlite3_errmsg(dbp));
-# endif
 
-return res == SQLITE_OK ? EXIM_DBPUTB_OK : EXIM_DBPUTB_DUP;
-# undef FMT
+/* Note that we return claiming a duplicate record for any error.
+ * It seem not uncommon to get a "database is locked" error.
+*/
+# define EXIM_DBPUTB_OK  0
+# define EXIM_DBPUTB_DUP (-1)
+
+static inline int
+exim_s_dbp(EXIM_DB * dbp, EXIM_DATUM * key, EXIM_DATUM * data, const char * sql)
+{
+return (SQLITE_DONE == exim_sqlprep_step(dbp, sql, key, data, NULL )) ? EXIM_DBPUTB_OK : EXIM_DBPUTB_DUP;
 }
 
 /* EXIM_DBPUT - returns nothing useful, assumes replace mode */
-
 static inline int
 exim_dbput(EXIM_DB * dbp, EXIM_DATUM * key, EXIM_DATUM * data)
 {
-/* DEBUG(D_hints_lookup) debug_printf_indent("exim_dbput()\n"); */
-(void) exim_s_dbp(dbp, key, data, US"REPLACE");
+# ifdef SQL_DEBUG
+DEBUG(D_hints_lookup) debug_printf_indent(EXIM_DBTYPE " put: key:%.*W data:%.*W\n", key->len, key->data, data->len, data->data );
+# endif
+(void) exim_s_dbp(dbp, key, data, "INSERT OR REPLACE INTO tblblob (ky, dat) VALUES(?, ?)");
 return 0;
 }
 
@@ -234,110 +225,52 @@ return 0;
 static inline int
 exim_dbputb(EXIM_DB * dbp, EXIM_DATUM * key, EXIM_DATUM * data)
 {
-return exim_s_dbp(dbp, key, data, US"ABORT");
+return exim_s_dbp(dbp, key, data, "INSERT OR ABORT INTO tblblob (ky, dat) VALUES(?, ?)");
 }
 
 /* EXIM_DBDEL */
 static inline int
 exim_dbdel(EXIM_DB * dbp, EXIM_DATUM * key)
 {
-# define FMT "DELETE FROM tbl WHERE ky = '%s';"
-uschar * encoded_key, * qry;
-int res;
-
-# ifdef COMPILE_UTILITY
-if (!(encoded_key = xtextencode(key->data, key->len)))
-  return EXIM_DBPUTB_DUP;
-res = snprintf(NULL, 0, FMT, encoded_key) +1;		/* res includes nul */
-if (!(qry = malloc(res))) return SQLITE_NOMEM;
-snprintf(CS qry, res, FMT, encoded_key);
-res = sqlite3_exec(dbp, CS qry, NULL, NULL, NULL);
-free(qry);
-
-# else
-encoded_key = xtextencode(key->data, key->len);
-qry = string_sprintf(FMT, encoded_key);
-res = sqlite3_exec(dbp, CS qry, NULL, NULL, NULL);
-
-# endif
-
-return res == SQLITE_OK ? EXIM_DBPUTB_OK : EXIM_DBPUTB_DUP;
-# undef FMT
+const char query[] = "DELETE FROM tblblob WHERE ky = ?";
+return (SQLITE_DONE == exim_sqlprep_step(dbp, query, key, NULL, NULL )) ? 0 : -1;
 }
 
-
 /* EXIM_DBCREATE_CURSOR - initialize for scanning operation */
-/* Cursors are inefficiently emulated by repeating searches */
 
 static inline EXIM_CURSOR *
 exim_dbcreate_cursor(EXIM_DB * dbp)
 {
-# ifdef COMPILE_UTILITY
-EXIM_CURSOR * c = malloc(sizeof(int));
-if (!c) return NULL;
-# else
-EXIM_CURSOR * c = store_malloc(sizeof(int));
+EXIM_CURSOR * cursor;
+
+cursor = exim_sqlprep(dbp, "SELECT ky FROM tblblob ORDER BY ky", NULL, NULL );
+if (!cursor) return NULL;
+# ifdef SQL_DEBUG
+DEBUG(D_hints_lookup) debug_printf_indent("prepared query: %s\n", sqlite3_sql(cursor));
 # endif
-*c = 0;
-return c;
+
+return cursor;
 }
 
 /* EXIM_DBSCAN */
-/* Note that we return the (next) key, not the record value.
-We allocate memory for the return. */
-
+/* Note that we return the (next) key into the key parameter, not the res parameter. */
 static inline BOOL
-exim_dbscan(EXIM_DB * dbp, EXIM_DATUM * key, EXIM_DATUM * res, BOOL first,
-  EXIM_CURSOR * cursor)
+exim_dbscan(EXIM_DB * dbp, EXIM_DATUM * key, EXIM_DATUM * res /* unused */, BOOL first /*unused*/, EXIM_CURSOR * cursor)
 {
-# define FMT "SELECT ky FROM tbl ORDER BY ky LIMIT 1 OFFSET %d;"
-uschar * qry;
-EXIM_DATUM encoded_key;
-BOOL ret;
-
-# ifdef COMPILE_UTILITY
-int i = snprintf(NULL, 0, FMT, *cursor)+1;
-
-if (!(qry = malloc(i))) return FALSE;
-snprintf(CS qry, i, FMT, *cursor);
-DEBUG(D_hints_lookup) debug_printf_indent("exim_dbscan(%s)\n", qry);
-ret = exim_dbget__(dbp, qry, &encoded_key);
-free(qry);
-
-# else	/*!COMPILE_UTILITY*/
-qry = string_sprintf(FMT, *cursor);
-DEBUG(D_hints_lookup) debug_printf_indent("exim_dbscan(%s)\n", qry);
-ret = exim_dbget__(dbp, qry, &encoded_key);
-
-# endif	/*COMPILE_UTILITY*/
-
-DEBUG(D_hints_lookup)
-  debug_printf_indent("exim_dbscan ret %c\n", ret ? 'T':'F');
-
-if (ret)
-  {
-  key->len = xtextdecode(encoded_key.data, &key->data);
-  *cursor = *cursor + 1;
-  }
-return ret;
-# undef FMT
+return (exim_sqlstep(dbp, cursor, key )==SQLITE_ROW);
 }
 
 /* EXIM_DBDELETE_CURSOR - terminate scanning operation. */
 static inline void
 exim_dbdelete_cursor(EXIM_CURSOR * cursor)
 {
-# ifdef COMPILE_UTILITY
-free(cursor);
-# else
-store_free(cursor);
-# endif
+if(cursor)
+  sqlite3_finalize(cursor);
 }
 
-
 /* EXIM_DBCLOSE */
 static inline void
-exim_dbclose_multi__(EXIM_DB * dbp)
+exim_dbclose_multi__(EXIM_DB *dbp)
 {
 sqlite3_close(dbp);
 }
@@ -359,19 +292,19 @@ exim_dbclose_multi__(dbp);
 static inline uschar *
 exim_datum_data_get(EXIM_DATUM * dp)
 { return US dp->data; }
-static inline void
+
+static void
 exim_datum_data_set(EXIM_DATUM * dp, void * s)
 { dp->data = s; }
- 
-static inline unsigned
+
+static unsigned
 exim_datum_size_get(EXIM_DATUM * dp)
 { return dp->len; }
+
 static inline void
 exim_datum_size_set(EXIM_DATUM * dp, unsigned n)
 { dp->len = n; }
 
-
-
 static inline void
 exim_datum_init(EXIM_DATUM * dp)
 { dp->data = NULL; }			/* compiler quietening */
@@ -386,7 +319,7 @@ exim_datum_free(EXIM_DATUM * dp)
 
 # define EXIM_DB_RLIMIT	150
 
-
 /* End of hints_sqlite.h */
 /* vi: aw ai sw=2
+ *
 */

